#lang racket

;; ------------------------------------------------------------------------
;; Sequencing expressions in Racket
;; ------------------------------------------------------------------------

;; ------------------------------------------------------------------------
;; an answer to the quick exercise

(+ (begin (display "left ") 1)
   (begin (display "right ") 2))

;; ------------------------------------------------------------------------
;; demo code from the reading for today

(begin (display "The answer is: ")
       (display (+ 2 4 (* 4 5))))

(newline)

((lambda (x y)
   (display "Simulating a let expression")
   (newline)
   (display (+ 2 x (* x y))))
 4 5)

(newline)

(define print-sign
  (lambda (n)
    (cond ((> n 0)  (display "positive") (newline)  1)
          ((< n 0)  (display "negative") (newline) -1)
          (else     (display "zero")     (newline)  0))))
(print-sign 4)

(define sign (print-sign 4))
sign
(display sign)
(+ 1 (print-sign 4))
; (+ 1 (display sign))

(+ (begin (display "first  ") 1)
   (begin (display "second ") 2))

;; ------------------------------------------------------------------------
