#lang racket
(provide for-each displayln)

;; ------------------------------------------------------------------------
;; You saw the functions in the reading for today.
;; ------------------------------------------------------------------------

(define for-each                     ; like map, but it doesn't use space
  (lambda (proc lst)
    (if (null? lst)
        (void)
        (begin
          (proc (first lst))
          (for-each proc (rest lst))))))

(define displayln                    ; replaces the 1-argument primitive
  (lambda lst
    (for-each display lst)
    (newline)))

;; ------------------------------------------------------------------------
